# Python Primer Design Library

[![Python Versions][language-badge]][language-link]
[![License][license-badge]][license-link]
[![MyPy Checked][type-checking-badge]][type-checking-link]
[![Poetry][poetry-badge]][poetry-link]
[![Ruff][ruff-badge]][ruff-link]

[language-badge]:       https://img.shields.io/badge/python-3.11_|_3.12-blue
[language-link]:        http://www.python.org/
[license-badge]:        http://img.shields.io/badge/license-MIT-blue.svg
[license-link]:         https://github.com/fulcrumgenomics/prymer/blob/main/LICENSE
[type-checking-badge]:  http://www.mypy-lang.org/static/mypy_badge.svg
[type-checking-link]:   http://mypy-lang.org/
[poetry-badge]:         https://img.shields.io/endpoint?url=https://python-poetry.org/badge/v0.json
[poetry-link]:          https://python-poetry.org/
[ruff-badge]:           https://img.shields.io/endpoint?url=https://raw.githubusercontent.com/astral-sh/ruff/main/assets/badge/v2.json
[ruff-link]:            https://docs.astral.sh/ruff/

[![Install with Bioconda][bioconda-badge]][bioconda-link]
[![PyPI version][pypi-badge]][pypi-link]

[bioconda-badge]:       https://img.shields.io/badge/install%20with-bioconda-brightgreen.svg?label=Install%20with
[bioconda-link]:        http://bioconda.github.io/recipes/prymer/README.html
[pypi-badge]:           https://img.shields.io/pypi/v/prymer?label=Install%20with%20PyPi
[pypi-link]:            https://pypi.python.org/pypi/prymer

[![Bioconda][bioconda-dl-badge]][bioconda-dl-link]
[![PyPI download total][pypi-downloads-badge]][pypi-downloads-link]


[bioconda-dl-badge]:    https://img.shields.io/conda/dn/bioconda/prymer.svg?label=Bioconda%20downloads
[bioconda-dl-link]:     https://anaconda.org/bioconda/prymer
[pypi-downloads-badge]: https://img.shields.io/pypi/dm/prymer.svg?label=PyPi%20downloads
[pypi-downloads-link]:  https://pypi.python.org/pypi/prymer

[![tests][python-tests-badge]][python-tests-link]
[![publish prymer][publish-prymer-badge]][publish-prymer-link]
[![Code Coverage][code-coverage-badge]][code-coverage-link]

[publish-prymer-badge]: https://github.com/fulcrumgenomics/prymer/actions/workflows/publish_prymer.yml/badge.svg
[publish-prymer-link]:  https://github.com/fulcrumgenomics/prymer/actions/workflows/publish_prymer.yml
[python-tests-badge]:   https://github.com/fulcrumgenomics/prymer/actions/workflows/tests.yml/badge.svg
[python-tests-link]:    https://github.com/fulcrumgenomics/prymer/actions/workflows/tests.yml
[code-coverage-badge]:  https://codecov.io/gh/fulcrumgenomics/prymer/branch/main/graph/badge.svg
[code-coverage-link]:   https://codecov.io/gh/fulcrumgenomics/prymer

<p>
<a href float="left"="https://fulcrumgenomics.com"><img src=".github/logos/fulcrumgenomics.svg" alt="Fulcrum Genomics" height="100"/></a>
</p>

[Visit us at Fulcrum Genomics](www.fulcrumgenomics.com) to learn more about how we can power your Bioinformatics with prymer and beyond.

<a href="mailto:contact@fulcrumgenomics.com?subject=[GitHub inquiry]"><img src="https://img.shields.io/badge/Email_us-brightgreen.svg?&style=for-the-badge&logo=gmail&logoColor=white"/></a>
<a href="https://www.fulcrumgenomics.com"><img src="https://img.shields.io/badge/Visit_Us-blue.svg?&style=for-the-badge&logo=wordpress&logoColor=white"/></a>

## Recommended Installation

The package `prymer` requires installation of [Primer3](https://github.com/primer3-org/primer3) and [interactive `bwa`](https://github.com/fulcrumgenomics/bwa-aln-interactive).

To satisfy these requirements, it is recommended to install using [bioconda](https://bioconda.github.io/):

```console
mamba install -c bioconda prymer
```

## Development and Testing

See the [developer's instructions][developers-instructions-link] for more information.

[developers-instructions-link]: https://prymer.readthedocs.io/en/latest/installation-and-developers-documentation.html#installation-for-development
